#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

struct allocblock {
    u_char high;
    u_char low;
    u_char count;
};

/* Directory entry */
struct dentry {
    u_char flag;
    char name[8];
    char ext[3];
    struct allocblock alloc[4];
    u_char last;
};

/* Continuation entry */
struct centry {
    struct allocblock alloc[7];
    u_int16_t cunused;
    u_char  last;
};

/* File information header */
struct fileinfo {
    u_char startmark;  /* Always $55 */
    u_char filetype;   /* $01 = BAS, $02 = BIN */
    u_char loadaddr_h; /* Load Address - typically $2401 for a .BAS file */
    u_char loadaddr_l;
    u_int16_t length;   /* Length of Data block that follows */
    u_int16_t execaddr; /* For a BASIC program this should be $8B8D */
    u_char endmark;    /* Always $AA */
};

struct diskinfo {
    int vdksize;
    int heads;
    int tracks;
    int sectors;
    char *diskname;
};

extern void vdkhead();
extern void seektodir();
extern void writehead();
